#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#define PI 3.14159265
/* work only with one channel */

void squarewave(int lenght)
{
			int cnt;
			for (cnt = 0 ;cnt<lenght; cnt++)
			{
				if (cnt < lenght/2)
				{
					printf("0.999 ");
				}
				else
				{
					printf("-0.999 ");
				}
			}
}

void sawtooth(int lenght)
{
			float cnt;
			for (cnt = -0.999 ;cnt<0.999; cnt += 2.0/(float)lenght)
			{
				printf("%f ",cnt);
			}
}

void reversesawtooth(int lenght)
{
			float cnt;
			for (cnt = 0.999 ;cnt>-0.999; cnt -= 2.0/(float)lenght)
			{
				printf("%f ",cnt);
			}
}

void triangle(int lenght)
{
			lenght = lenght/2;
			sawtooth(lenght);
			reversesawtooth(lenght);
}

void noise(int lenght)
{
	srand(time(NULL));
	
			int cnt;
			for (cnt = 0 ;cnt<lenght; cnt++)
			{
				printf("%f ",((float)rand())/RAND_MAX);
			}
}

void sinusoidal(int lenght)
{
			int cnt;
			for (cnt = 0 ;cnt<lenght; cnt++)
			{
				printf("%f ",sin(cnt*PI/(lenght/2)));
			}
}

int main(int argc, char * argv[])
{
	char c;
	char wordv[80];
	int wordc = 0;
	
	while (c != EOF)
	{
		c = getchar();
		if ((c != ' ')&&(c != '\n'))
		{
			wordv[wordc] = c;
			wordc++;
		}
		else
		{
			wordc = 0;
			int lenght = atoi(wordv);
			
			if (argc == 2)
			{
				if(!strcmp(argv[1],"square"))
				{
					squarewave(lenght);
				}
				if(!strcmp(argv[1],"sawtooth"))
				{
					sawtooth(lenght);
				}
				if(!strcmp(argv[1],"reversesawtooth"))
				{
					reversesawtooth(lenght);
				}
				if(!strcmp(argv[1],"triangle"))
				{
					triangle(lenght);
				}
				if(!strcmp(argv[1],"sinusoidal"))
				{
					sinusoidal(lenght);
				}
				if(!strcmp(argv[1],"noise"))
				{
					noise(lenght);
				}
			}

			int clear;
			for (clear = 0; clear < 80 ; clear++)
			{
				wordv[clear] = ' ';
			}
		}
	}

	return(0);
}
